<template>
  <section class="sg-blog-section sg-filter" :class="activeClass">
    <div class="container">
      <div class="title blog-header justify-content-between">
        <h1>Blog News</h1>
        <div class="right-content">
          <select v-model="form.sort" @change="filterBlogs" class="form-control">
            <option value="newest">{{ lang.newest }}</option>
            <option value="oldest">{{ lang.oldest }}</option>
            <option value="viewed">{{ lang.most_viewed }}</option>
          </select>
          <div class="d-flex gap-3">
            <div class="sg-search">
              <div class="search-form blog-search">
                <form @submit.prevent="filterBlogs">
                  <input type="text" class="form-control" v-model="form.title" :placeholder="lang.search_blog">
                  <loading_button v-if="loading"></loading_button>
                  <button v-else type="submit"><span class="mdi mdi-name mdi-magnify">
                    <svg width="20" height="20" viewBox="0 0 32 32" fill="none" xmlns="http://www.w3.org/2000/svg">
                      <path d="M14.2 6.04998C18.7563 6.04998 22.45 9.74363 22.45 14.3M23.537 23.6306L30.7 30.8M27.4 14.3C27.4 21.5902 21.4902 27.5 14.2 27.5C6.90984 27.5 1 21.5902 1 14.3C1 7.00981 6.90984 1.09998 14.2 1.09998C21.4902 1.09998 27.4 7.00981 27.4 14.3Z" stroke="#660F1F" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"/>
                    </svg>
                  </span></button>
                </form><!-- /form -->
              </div><!-- /form -->
            </div><!-- /.sg-search -->
            <ul class="filter-tabs global-list">
              <li class="grid-view-tab" @click="activeClass = 'grid-view-tab'"
                  :class="{'active' : activeClass == 'grid-view-tab' || activeClass == ''}">
                <span class="mdi mdi-name mdi-grid"></span></li>
              <li class="list-view-tab" @click="activeClass = 'list-view-tab'"
                  :class="{'active' : activeClass == 'list-view-tab' }">
                <span class="mdi mdi-name mdi-format-list-bulleted"></span></li>
            </ul>
          </div>
        </div>
      </div>
      <div class="row" v-if="is_shimmer">
        <div class="col-md-6 col-lg-3" v-for="(blog,i) in blogs.data" :key="i">
          <div class="post">
            <div class="entry-header">
              <div class="entry-thumbnail">
                <router-link :to="{ name: 'blog.details',params:{slug:blog.slug}}"><img
                    loading="lazy" :src="blog.thumbnail" :alt="blog.title"
                    class="img-fluid"></router-link>
              </div>
            </div>
            <div class="entry-content">
              <router-link :to="{ name: 'blog.details',params:{slug:blog.slug}}">
                <h1 class="entry-title text-ellipse">{{ blog.title }}</h1>
              </router-link>
              <p>{{ blog.short_description }}</p>
              <router-link :to="{ name: 'blog.details',params:{slug:blog.slug}}" class="more">
                {{ lang.read_more }}
              </router-link>
            </div>
          </div>
        </div>
      </div><!-- /.row -->
      <div class="row" v-else-if="shimmer">
        <div class="col-md-6 col-lg-3" v-for="(blog,i) in 12" :key="i">
          <div class="post">
            <shimmer></shimmer>
          </div>
        </div>
      </div><!-- /.row -->
      <div class="show-more mt-4" v-if="next_page_url && !loading">
        <a href="javaScript:void(0)" @click="loadMoreData()" class="btn btn-primary">{{ lang.show_more }}</a>
      </div>
      <div class="col-md-12 text-center show-more" v-show="loading">
        <loading_button :class_name="'btn btn-primary'"></loading_button>
      </div>
    </div><!-- /.container -->
  </section>
</template>

<script>
import shimmer from "../partials/shimmer";

export default {
  name: "blogs",
  data() {
    return {
      page: 1,
      activeClass: "",
      form: {
        sort: 'newest',
        slug: this.$route.params.slug,
        title: null,
      },
      loading: false,
      is_shimmer: false,
      next_page_url: false,

    }
  },
  components: {
    shimmer
  },
  mounted() {
    if (this.lengthCounter(this.blogs) == 0) {
      this.allBlogs();
    }
    if (this.lengthCounter(this.blogs) > 0) {
      this.is_shimmer = true
    }
  },
  computed: {
    blogs() {
      return this.$store.getters.getBlogs;
    },
    shimmer() {
      return this.$store.state.module.shimmer
    },
  },
  watch: {
    $route(from) {
      if (from.name == 'blogs') {
        this.form.slug = null;
      }

      this.$store.dispatch('blogs', this.form);
    }
  },
  methods: {
    loadMoreData() {
      this.loading = true
      this.$Progress.start();
      axios.get(this.next_page_url, {params: this.form}).then((response) => {
        if (response.data.error) {
          toastr.error(response.data.error, this.lang.Error + ' !!');
        } else {
          this.loading = false
          let blogs = response.data.blogs.data;

          if (blogs.length > 0) {
            for (let i = 0; i < blogs.length; i++) {
              this.blogs.data.push(blogs[i]);
            }
          }
          this.$Progress.finish();
        }
        this.next_page_url = response.data.blogs.next_page_url;
      });
    },
    filterBlogs() {
      this.page = 1;
      this.allBlogs(this.form);
    },
    allBlogs() {
      this.loading = true;
      let url = this.getUrl('home/blogs?page=1')
      axios.get(url, {params: this.form}).then((response) => {
        this.is_shimmer = true;
        this.loading = false;
        if (response.data.error) {
          this.$Progress.fail();
          toastr.error(response.data.error, this.lang.Error + ' !!');
        } else {
          this.$store.commit("getBlogs", response.data.blogs);
          this.next_page_url = response.data.blogs.next_page_url;
          this.page++;
          this.$Progress.finish();
        }

      }).catch((error) => {
        this.loading = false;
        this.is_shimmer = true
        this.$Progress.fail();

        if (error.response && error.response.status == 422) {
          toastr.error(response.data.error, this.lang.Error + ' !!');
        }
      })
    },
  }

}
</script>
<style scoped>
.title {
  border-bottom: 0;
}
.title h1 {
  margin-bottom:0;
}
.list-view-tab .post .entry-content {
  min-height: 182px;
  position: relative;
}
.list-view-tab .more {
    position: absolute;
    bottom: 10px;
    right: 15px;
  }
</style>
